## openjdk-25-crac 25~26ea

=== debian/changelog ===
openjdk-25-crac (25~26ea-0ubuntu1) questing; urgency=medium

  * Initial release. (LP: #2115318)

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Fri, 01 Aug 2025 21:08:03 +0530

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
include /usr/share/dpkg/buildflags.mk

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
# see https://bugs.openjdk.org/browse/JDK-8321125 (armhf removed)
# see https://bugs.openjdk.org/browse/JDK-8338285,
# https://bugs.openjdk.org/browse/JDK-8341871 (i386 removed)
hotspot_archs	= amd64 arm64 ppc64 ppc64el riscv64 s390x

jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel loong64 mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk-crac
basename	= openjdk-$(shortver)-crac
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),2514,2512)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),2506,2505)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.25.0
shortver	= 25
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_jdk_upstream  := $(shell echo $(v_upstream) | sed 's/\.[^.]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')

ifeq (yes,$(is_upstream_release))
  v_upbase      := $(word 1, $(subst +, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst +, , $(v_upstream)))
  v_jdk_upbuild := $(word 2, $(subst +, , $(v_jdk_upstream)))
  ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
else
  v_upbase      := $(word 1, $(subst ~, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst ~, , $(v_upstream)))
  v_jdk_upbuild := $(word 2, $(subst +, , $(v_jdk_upstream)))
  ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
  testsuitedir	=	$(basedir)/testsuite
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
  testsuitedir	=	$(basedir)/testsuite
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
  testimg	= images/test
else
  sdkimg	= images/jdk
  build_target	= images test-image
  testimg	= images/test
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifneq (,$(filter $(distrel), bookworm bullseye))
  jtreg_pkg = jtreg# debian will have jtreg7 in jtreg package
  testng_pkg = libtestng7-java
else
  jtreg_pkg = jtreg7
  testng_pkg = libtestng7-java
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# time outs on the builders
ifneq (,$(filter $(distribution), Debian))
  ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    with_check = disabled running check on $(DEB_HOST_ARCH)
  endif
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
  with_check = disabled for $(distrel), no $(jtreg_pkg)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arc=arc arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 loong64=loong64 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-25-openjdk-$(DEB_BUILD_ARCH)/bin/javac \

=== debian/watch ===
version=4
opts="pgpmode=default,\
pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;s/([^\/]+)\.tar\.gz/$1\/@PACKAGE@-$1\.tar\.gz.asc/,\
uversionmangle=s/-rc/~rc/,\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1ea.tar.gz%,\
repack,repacksuffix=ea,oversionmangle=s/\+(\d+)/\~$1/,dversionmangle=s/\~(\d*)ea$/\+$1/,\
compression=xz" \
    https://github.com/canonical/openjdk-25-crac/tags \
    (?:.*?/)?jdk-(25[\+\.\d]*)\.tar\.gz

opts=\
component=googletest,\
repack,\
compression=xz \
    https://github.com/google/googletest/tags \
    (?:.*?/)?v(1.14.0)\.tar\.gz 1.14.0

## openjdk-25-crac 25%2B36

=== debian/watch ===
version=4
opts="pgpmode=default,\
pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;s/([^\/]+)\.tar\.gz/$1\/@PACKAGE@-$1\.tar\.gz.asc/,\
compression=xz" \
    https://github.com/canonical/openjdk-25-crac/tags \
    (?:.*?/)?jdk-(25[\+\.\d]*)\.tar\.gz

opts=\
component=googletest,\
repack,\
compression=xz \
    https://github.com/google/googletest/tags \
    (?:.*?/)?v(1.14.0)\.tar\.gz 1.14.0

## openjdk-25-crac 25+36

=== Makefile ===
#
# Copyright (c) 2012, 2025, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.  Oracle designates this
# particular file as subject to the "Classpath" exception as provided
# by Oracle in the LICENSE file that accompanied this code.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

###
### This file is just a very small wrapper which will include make/PreInit.gmk,
### where the real work is done. This wrapper also performs some sanity checks
### on make that must be done before we can include another file.
###

# The shell code below will be executed on /usr/bin/make on Solaris, but not in GNU Make.
# /usr/bin/make lacks basically every other flow control mechanism.
.TEST_FOR_NON_GNUMAKE:sh=echo You are not using GNU Make/gmake, this is a requirement. Check your path. 1>&2 && exit 1

# The .FEATURES variable is likely to be unique for GNU Make.
ifeq ($(.FEATURES), )
  $(info Error: '$(MAKE)' does not seem to be GNU Make, which is a requirement.)
  $(info Check your path, or upgrade to GNU Make 3.81 or newer.)
  $(error Cannot continue)
endif

# Assume we have GNU Make, but check version.
ifeq ($(strip $(foreach v, 3.81% 3.82% 4.%, $(filter $v, $(MAKE_VERSION)))), )
  $(info Error: This version of GNU Make is too low ($(MAKE_VERSION)).)
  $(info Check your path, or upgrade to GNU Make 3.81 or newer.)
  $(error Cannot continue)
endif

# In Cygwin, the MAKE variable gets prepended with the current directory if the
# make executable is called using a Windows mixed path (c:/cygwin/bin/make.exe).
ifneq ($(findstring :, $(MAKE)), )
  MAKE := $(patsubst $(CURDIR)%, %, $(patsubst $(CURDIR)/%, %, $(MAKE)))
endif

# Locate this Makefile
ifeq ($(filter /%, $(lastword $(MAKEFILE_LIST))),)
  makefile_path := $(CURDIR)/$(strip $(lastword $(MAKEFILE_LIST)))
else
  makefile_path := $(lastword $(MAKEFILE_LIST))
endif
TOPDIR := $(strip $(patsubst %/, %, $(dir $(makefile_path))))

# ... and then we can include the real makefile to bootstrap the build
include $(TOPDIR)/make/PreInit.gmk

=== make/devkit/Makefile ===
#
# Copyright (c) 2013, 2024, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.  Oracle designates this
# particular file as subject to the "Classpath" exception as provided
# by Oracle in the LICENSE file that accompanied this code.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

################################################################################
#
# This Makefile, together with Tools.gmk, can be used to compile a set of
# gcc based cross compilation, portable, self contained packages, capable
# of building OpenJDK.
#
# By default this Makefile will build a native toolchain for the current
# platform if called with something like this:
#
# make tars BASE_OS=OL
#
# To build the full set of crosstools for additional platforms, use a command
# line looking like this:
#
# make TARGETS="aarch64-linux-gnu" BASE_OS=Fedora
# or
# make TARGETS="arm-linux-gnueabihf ppc64-linux-gnu" BASE_OS=Fedora BASE_OS_VERSION=17
#
# to build several devkits for a specific OS version at once.
# You can find the final results under ../../build/devkit/result/<host>-to-<target>
#
# You may want the native toolchain to be used when compiling the cross
# compilation toolchains. To achieve this, first build the native toolchain,
# then add the bin directory from this build to the path when invoking this
# makefile again for cross compilation. Ex:
#
# PATH=$PWD/../../build/devkit/result/x86_64-linux-gnu-to-x86_64-linux-gnu/bin:$PATH \
#    make TARGETS="arm-linux-gnueabihf,ppc64-linux-gnu" BASE_OS=Fedora
#
# This is the makefile which iterates over all host and target platforms.
#

COMMA := ,

os := $(shell uname -o)
cpu := $(shell uname -p)

# Figure out what platform this is building on.
me := $(cpu)-$(if $(findstring Linux,$(os)),linux-gnu)

$(info Building on platform $(me))

#
# By default just build for the current platform, which is assumed to be Linux
#
ifeq ($(TARGETS), )
  platforms := $(me)
  host_platforms := $(platforms)
else
  platforms := $(subst $(COMMA), , $(TARGETS))
  host_platforms := $(me)
endif
target_platforms := $(platforms)
$(info host_platforms $(host_platforms))
$(info target_platforms $(target_platforms))

all compile : $(platforms)

ifeq ($(SKIP_ME), )
  $(foreach p,$(filter-out $(me),$(platforms)),$(eval $(p) : $$(me)))
endif

OUTPUT_ROOT = $(abspath ../../build/devkit)
RESULT = $(OUTPUT_ROOT)/result

submakevars = HOST=$@ BUILD=$(me) RESULT=$(RESULT) OUTPUT_ROOT=$(OUTPUT_ROOT)

$(host_platforms) :
	@echo 'Building compilers for $@'
	@echo 'Targets: $(target_platforms)'
	for p in $(filter $@, $(target_platforms)) $(filter-out $@, $(target_platforms)); do \
	  $(MAKE) -f Tools.gmk download-rpms $(submakevars) \
              TARGET=$$p PREFIX=$(RESULT)/$@-to-$$p && \
	  $(MAKE) -f Tools.gmk all $(submakevars) \
              TARGET=$$p PREFIX=$(RESULT)/$@-to-$$p && \
	  $(MAKE) -f Tools.gmk ccache $(submakevars) \
              TARGET=$@ PREFIX=$(RESULT)/$@-to-$$p || exit 1 ; \
	done
	@echo 'All done"'

today := $(shell date +%Y%m%d)

define Mktar
  $(1)-to-$(2)_tar = $$(RESULT)/sdk-$(1)-to-$(2)-$$(today).tar.gz
  $$($(1)-to-$(2)_tar) : PLATFORM = $(1)-to-$(2)
  TARFILES += $$($(1)-to-$(2)_tar)
endef

$(foreach p,$(host_platforms),$(foreach t,$(target_platforms),$(eval $(call Mktar,$(p),$(t)))))

tars : all $(TARFILES)
onlytars : $(TARFILES)
%.tar.gz :
	$(MAKE) -r -f Tars.gmk SRC_DIR=$(RESULT)/$(PLATFORM) TAR_FILE=$@

clean :
	rm -rf $(addprefix ../../build/devkit/, result $(host_platforms))
dist-clean: clean
	rm -rf $(addprefix ../../build/devkit/, src download)

FORCE :
.PHONY : all compile tars $(configs) $(host_platforms) clean dist-clean

=== src/jdk.incubator.vector/unix/native/libsleef/upstream/src/gencoef/Makefile ===
.PHONY: all
all : gencoef mkrempitab mkrempitabqp

gencoef : gencoef.c simplexfr.c sp.h dp.h ld.h qp.h
        gcc -O gencoef.c simplexfr.c -o gencoef -lmpfr -lm

mkrempitab : mkrempitab.c
        gcc -O mkrempitab.c -o mkrempitab -lmpfr

mkrempitabqp : mkrempitabqp.c
        gcc -O mkrempitabqp.c -o mkrempitabqp -lmpfr

.PHONY: clean
clean :
        rm -f gencoef gencoefdp gencoefld mkrempitab mkrempitabqp a.out *~
        rm -f *.obj *.lib *.dll *.exp *.exe

=== debian/changelog ===
openjdk-25-crac (25+36-0ubuntu1) questing; urgency=medium

  * OpenJDK with CRaC support v25 GA, based on jdk-25+36
    (LP: #2120601).
  * d/rules: merge delta from openjdk-25 packaging.
  * d/watch: Regenerate for upstream release.
  * d/patches: add patch to fix ftbfs in zero variant

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Thu, 18 Sep 2025 18:02:42 +0530

=== debian/control ===
Source: openjdk-25-crac
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Pushkar Kulkarni <pushkar.kulkarni@canonical.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg7 (>= 7.5.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
  autoconf, automake, ant, ant-optional,
  g++-14 <!cross>,
  openjdk-25-jdk-headless:native | openjdk-24-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
  libffi-dev, libffi-dev:native,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
  libnss3-dev (>= 2:3.17.1),
  openjdk-25-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://openjdk.org/projects/crac/
Vcs-Browser: https://github.com/canonical/openjdk-25-crac/tree/crac
Vcs-Git: https://github.com/canonical/openjdk-25-crac.git -b crac

Package: openjdk-25-crac-jdk-headless
Architecture: amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-25-crac-demo, openjdk-25-crac-source
Description: OpenJDK Development Kit (JDK) (headless) with CRaC support
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language. This JDK
 is further specialized to support the Coordinated Restore at Checkpoint
 capability. 

Package: openjdk-25-crac-jre-headless
Architecture: amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}, crac-criu
Recommends: ${dlopenhl:Recommends},
  ${fontmanager:Recommends}, ${jsound:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Description: OpenJDK Java runtime with CRaC, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}. This package also provides the "Coordinated
 Restore at Checkpoint" capability.

Package: openjdk-25-crac-jdk
Architecture: amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre (= ${binary:Version}),
  openjdk-25-crac-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-25-crac-demo, openjdk-25-crac-source, visualvm
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 This package also provides the "Coordinated Restore at Checkpoint"
 capability.

Package: openjdk-25-crac-jre
Architecture: amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre-headless (= ${binary:Version}),
  ${dlopenjre:Depends}, ${fontmanager:Depends}, ${jsound:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}. This package also provides the "Coordinated
 Restore at Checkpoint" capability.

Package: openjdk-25-crac-demo
Architecture: amd64
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-25-crac-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-25-crac-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-25-crac-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-25-crac-dbg
Architecture: amd64
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre-headless (= ${binary:Version}),
   ${misc:Depends},${shlibs:Depends}
Recommends: openjdk-25-crac-jre (= ${binary:Version})
Suggests: openjdk-25-crac-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-25-crac-testsupport
Architecture: amd64
Multi-Arch: same
Depends: openjdk-25-crac-jdk (= ${binary:Version}),
  build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
  libatk-wrapper-java-jni, jtreg7 (>= 7.5.1+1~), libtestng7-java,
  ${shlibs:Depends},
  ${misc:Depends}
Description: Java runtime based on OpenJDK (regression test support)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains all the binary files needed to run the
 OpenJDK autopkg tests.

Package: openjdk-25-crac-jre-zero
Architecture: amd64
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-crac-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM. This packages also provides
 the "Coordinated Restore at Checkpoint" capability.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
--- 
+++ 
@@ -87,7 +87,7 @@
   is_default = yes
 endif
 
-#is_upstream_release = yes
+is_upstream_release = yes
 
 srcdir		= .
 builddir	= build
@@ -181,12 +181,6 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
-# time outs on the builders
-ifneq (,$(filter $(distribution), Debian))
-  ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
-    with_check = disabled running check on $(DEB_HOST_ARCH)
-  endif
-endif
 # no jtreg backport yet
 ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
   with_check = disabled for $(distrel), no $(jtreg_pkg)
@@ -230,3 +224,12 @@
 
 BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
 			/usr/lib/jvm/java-25-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+			/usr/lib/jvm/java-24-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+		))))
+
+ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
+else
+  BUILDJDK_HOME = $(BOOTJDK_HOME)
+endif
+

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-25-jre-headless
Restrictions: allow-stderr, superficial

Test-Command: javac --version
Depends: openjdk-25-jdk-headless
Restrictions: allow-stderr, superficial

Tests: hotspot-autopkgtest.sh
Depends: @, jtreg7 (>= 7.5.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: jdk-autopkgtest.sh
Depends: @, jtreg7 (>= 7.5.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: dependencies.sh
Depends: @, build-essential, bash
Restrictions: allow-stderr, skippable, flaky

## openjdk-25-crac 25.0.1+8

=== debian/changelog ===
openjdk-25-crac (25.0.1+8-0ubuntu1) resolute; urgency=medium

  * New release based on OpenJDK 25.0.1 release, build 8.
    - CVEs:
      + CVE-2025-53057, 8360937: Enhance certificate handling.
      + CVE-2025-53066, 8356294: Enhance Path Factories.
      + CVE-2025-61748, 8359454: Enhance String handling.
  * d/tests/*: sync latest changes from openjdk-25.
  * d/patches: update latest patches from openjdk-25.
  * Update source URL in copyright-generator and d/copyright.
  * d/control: enable building with gcc-15, misc changes.
  * d/{control.*, watch.in}: enable regeneration for older
    lts releases.

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Mon, 17 Nov 2025 18:47:17 +0530

=== debian/control ===
--- 
+++ 
@@ -9,16 +9,17 @@
   time, strip-nondeterminism, debugedit (>= 4.16),
   jtreg7 (>= 7.5.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
-  g++-14 <!cross>,
+  g++-15 <!cross>,
   openjdk-25-jdk-headless:native | openjdk-24-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
   libnss3-dev (>= 2:3.17.1),
   openjdk-25-jdk-headless <cross>,
+  crac-criu,
 Build-Depends-Indep: graphviz, pandoc,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://openjdk.org/projects/crac/
 Vcs-Browser: https://github.com/canonical/openjdk-25-crac/tree/crac
 Vcs-Git: https://github.com/canonical/openjdk-25-crac.git -b crac
@@ -34,7 +35,7 @@
  OpenJDK is a development environment for building applications,
  applets, and components using the Java programming language. This JDK
  is further specialized to support the Coordinated Restore at Checkpoint
- capability. 
+ capability.
 
 Package: openjdk-25-crac-jre-headless
 Architecture: amd64

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-25-crac-jre-headless
Restrictions: allow-stderr, superficial

Test-Command: javac --version
Depends: openjdk-25-crac-jdk-headless
Restrictions: allow-stderr, superficial

Tests: hotspot-autopkgtest.sh
Depends: @, jtreg7 (>= 7.5.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree
Architecture: amd64

Tests: jdk-autopkgtest.sh
Depends: @, jtreg7 (>= 7.5.1+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree
Architecture: amd64

Tests: dependencies.sh
Depends: @, build-essential, bash
Restrictions: allow-stderr, skippable, flaky

=== debian/watch ===
--- 
+++ 
@@ -1,6 +1,9 @@
 version=4
 opts="pgpmode=default,\
 pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;s/([^\/]+)\.tar\.gz/$1\/@PACKAGE@-$1\.tar\.gz.asc/,\
+uversionmangle=s/-rc/~rc/,\
+filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
+repack,\
 compression=xz" \
     https://github.com/canonical/openjdk-25-crac/tags \
     (?:.*?/)?jdk-(25[\+\.\d]*)\.tar\.gz

## openjdk-25-crac 25.0.2+10

=== debian/changelog ===
openjdk-25-crac (25.0.2+10-0ubuntu1~25.10) questing-security; urgency=medium

  * Upload to Ubuntu 25.10.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Fri, 30 Jan 2026 23:37:33 +1300

openjdk-25-crac (25.0.2+10-0ubuntu1) resolute; urgency=medium

  * New release based on OpenJDK 25.0.2 release, build 10.
    - CVEs:
      + CVE-2026-21945: 8368032: Enhance Certificate Checking.
      + CVE-2026-21932: 8359501: Enhance Handling of URIs.
      + CVE-2026-21933: 8362632: Improve HttpServer Request handling.
      + CVE-2026-21925: 8341496: Improve JMX connections.
  * d/rules: Use jtreg8 package for the tests.
  * d/p/power-opt.diff: Refresh patch.
  * Drop patches applied upstream:
     - d/p/jdk-8359735.patch.
     - d/p/jdk-8369450-proposed.patch.
     - d/p/jdk-8370049-proposed.patch.
  * d/s/lintian-overrides: Update override comment.
  * d/rules: Use generic code to replace bundled jquery.
  * d/JB-doc.overrides.in: Drop binary package bundled jquery
    override. The override is not needed for the binary package.
  * d/t/control.in: Remove flaky and skippable flag from dependencies.sh
    test and install only jre package.
  * d/{control, t/control}: Regenerate.
  * d/t/dependencies.in: Relax PC/SC library assertion,
    regenerate d/t/dependencies.sh.
  * d/t/write-problems.{in,sh}: Remove -crac suffix when filtering
    problem list.
  * d/t/problems.csv: Synchronize problemlist with openjdk-25.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Mon, 26 Jan 2026 20:43:23 +1300

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
-  jtreg7 (>= 7.5.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
+  jtreg8 (>= 8+2~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
   g++-15 <!cross>,
   openjdk-25-jdk-headless:native | openjdk-24-jdk-headless:native,
@@ -145,7 +145,7 @@
 Multi-Arch: same
 Depends: openjdk-25-crac-jdk (= ${binary:Version}),
   build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
-  libatk-wrapper-java-jni, jtreg7 (>= 7.5.1+1~), libtestng7-java,
+  libatk-wrapper-java-jni, jtreg8 (>= 8+2~), libtestng7-java,
   ${shlibs:Depends},
   ${misc:Depends}
 Description: Java runtime based on OpenJDK (regression test support)

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-25-crac-jre-headless
Restrictions: allow-stderr, superficial

Test-Command: javac --version
Depends: openjdk-25-crac-jdk-headless
Restrictions: allow-stderr, superficial

Tests: hotspot-autopkgtest.sh
Depends: @, jtreg8 (>= 8+2~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree
Architecture: amd64

Tests: jdk-autopkgtest.sh
Depends: @, jtreg8 (>= 8+2~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree
Architecture: amd64

Tests: dependencies.sh
Depends: openjdk-25-crac-jre-headless, build-essential, bash
Restrictions: allow-stderr
